OpenMesh::Subdivider::Uniform::CatmullClarkT< MeshType, RealType > Class Template Reference

Based on code from Leon Kos, CAD lab, Mech.Eng., University of Ljubljana, Slovenia (http://www.lecad.fs.uni-lj.si/~leon) More...

`#include <CatmullClarkT.hh>`

Inheritance diagram for OpenMesh::Subdivider::Uniform::CatmullClarkT< MeshType, RealType >:
[legend]
Collaboration diagram for OpenMesh::Subdivider::Uniform::CatmullClarkT< MeshType, RealType >:
[legend]

## Public Types

typedef MeshType::FaceHandle | FaceHandle
typedef MeshType::VertexHandle | VertexHandle
typedef MeshType::EdgeHandle | EdgeHandle
typedef MeshType::HalfedgeHandle | HalfedgeHandle
typedef MeshType::Point | Point
typedef MeshType::Normal | Normal
typedef MeshType::FaceIter | FaceIter
typedef MeshType::EdgeIter | EdgeIter
typedef MeshType::VertexIter | VertexIter
typedef MeshType::VertexEdgeIter | VertexEdgeIter
typedef MeshType::VertexFaceIter | VertexFaceIter
typedef MeshType::VOHIter | VOHIter
typedef SubdividerT< MeshType, RealType > | parent_t
Public Types inherited from OpenMesh::Subdivider::Uniform::SubdividerT< MeshType, RealType >
typedef MeshType | mesh_t
typedef RealType | real_t

## Public Member Functions

| CatmullClarkT ()
| Constructor.
| CatmullClarkT (MeshType &_m)
| Constructor.
const char * | name () const
| Return name of subdivision algorithm.
Public Member Functions inherited from OpenMesh::Subdivider::Uniform::SubdividerT< MeshType, RealType >
virtual | ~SubdividerT ()
| Destructor (calls detach())
| SubdividerT (void)
| Constructor to be used with interface 2. More...
| SubdividerT (MeshType &_m)
| Constructor to be used with interface 1 (calls attach()) More...
bool | operator() (MeshType &_m, size_t _n, const bool _update_points=true)
| Subdivide the mesh `_m` `_n` times. More...
bool | attach (MeshType &_m)
| Attach mesh `_m` to self. More...
bool | operator() (size_t _n, const bool _update_points=true)
| Subdivide the attached `_n` times. More...
void | detach (void)
| Detach an eventually attached mesh. More...

## Protected Member Functions

virtual bool | prepare (MeshType &_m)
| Initialize properties and weights.
virtual bool | cleanup (MeshType &_m)
| Remove properties and weights.
virtual bool | subdivide (MeshType &_m, size_t _n, const bool _update_points=true)
| Execute n subdivision steps. More...
Overload theses methods

## Detailed Description

### template<typename MeshType, typename RealType = double>
class OpenMesh::Subdivider::Uniform::CatmullClarkT< MeshType, RealType >

Based on code from Leon Kos, CAD lab, Mech.Eng., University of Ljubljana, Slovenia (http://www.lecad.fs.uni-lj.si/~leon)

Note
  Needs a PolyMesh to work on!

## Member Function Documentation

## subdivide()

template<typename MeshType , typename RealType >

bool OpenMesh::Subdivider::Uniform::CatmullClarkT< MeshType, RealType >::subdivide | ( | MeshType & | _m,
|  | size_t | _n,
|  | const bool | _update_points = `true`
| ) |  |

protectedvirtual

Execute n subdivision steps.

Parameters

  _m | Mesh to work on
  _n | Number of iterations
  _update_points | Unused here

Returns
  successful?

Implements OpenMesh::Subdivider::Uniform::SubdividerT< MeshType, RealType >.

The documentation for this class was generated from the following files:

- OpenMesh/Tools/Subdivider/Uniform/CatmullClarkT.hh
- OpenMesh/Tools/Subdivider/Uniform/CatmullClarkT.cc